/* ESERCIZIO (del 10-5-2018)
 Definire un ADT per oggetti che forniscano valori Non-Modificabili da 
 utilizzare in modo simile ai valori stack bounded di int introdotti
 da StackImm in slide di Lezione15. 
 Questo ADT deve trattare stack polimorfi e fornire le seguenti opera-
 zioni:
            empty: int -> Stack<A>               (dimensione massima)
            push: A -> Stack<A> -> A
            toString: Stack<A> -> String
            top: StackADT<A> -> A
            pop: Stack<A> -> Stack<A>
            size: Stack<A> -> int
            isin: A -> Stack<A> -> boolean
            waitUp: A ->Stack<A> -> int          (quanti prima)
            addAll: Vector<A> -> Stack<A> -> Stack<A>
            remove: A -> Stack<A> -> Stack<A>    (rimuove prima occorrenza)

 Prologo: Intero sviluppo in package di nome StackPack
 Prologo: Creare 4 file:
    1 per la API STACK<A>
    1 per la classe Stack<A>
    1 per le eccezioni, newExc
    1 per i codici di tests.
 (a) Fornire API
 (b) Fornire Stato Concreto, AF e C
 (c-d-e-f) Sviluppo:
    (c) Fornire successiva operazione nell'ordine e 
        ad ogni definizione procedere con (d),(e),(f)
    (d) Completare la segnatura con le eccezioni sollevate
    (e) Aggiungere definizione classi di eccezioni relative
    (f) compilare ed eseguire test di uso
  */

package StackPack;

import java.io.*;
import java.util.*;

public class Stack<A> implements API<A>{
    private A elm;
    private Stack<A> next;
    private int size;
    private int max;
    /*
     AF(c) = [] iff (c.size = 0)
     AF(c) = [v1,...,vn] iff (c.size > 0)&&(c.size = n)&&
                          (vn = elm)&&
                          (AF(c.next) = [v1,...,vn-1])
     I(c) = (c.size >= 0)&&(c.size <= c.max)&&
            (c.size > 0 => c.elm != null) &&
            (c.size > 1 => c.next != null) &&
            (c.next != null => (c.next.max = c.max &&
                                c.next.size = c.size-1))
     */
    public Stack<A> empty(int n){
        Stack<A> ret = new Stack<A>();
        ret.max = n;
        return ret;
    }
    public Stack<A> push(A x)throws FullStackException{
        if (size == max) throw new FullStackException("push",max);
        Stack<A> ret = new Stack<A>();
        ret.size = this.size+1;
        ret.max = this.max;
        ret.elm = x;
        ret.next = this;
        return ret;
    }
    public String toString(){
        if (size == 0) return "[ ]";
        if (size == 1) return "[" + elm.toString() + "]";
        String ret = next.toString();
        ret = ret.substring(0,ret.length()-1);
        return (ret + ", " + elm.toString() + "]");
    }
    public A top() throws EmptyStackException{
	    if (size == 0) throw new EmptyStackException("top");
	    return elm;
    }
    public Stack<A> pop()throws EmptyStackException{
	    if (size == 0) throw new EmptyStackException("pop");
	    return next;
    }
    public int size(){
        return size;
    }
    public boolean isin(A x){
        if (size == 0) return false;
        return (elm.equals(x) || next.isin(x));
    }
}
			   
